<template>
    <div class="edit-popup">
        <popup ref="popupRef" :title="popupTitle" :async="true" width="550px" @confirm="handleSubmit"
            @close="handleClose">
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="所属ID" prop="pid">
                    <!-- <el-input v-model="formData.pid" clearable placeholder="请输入所属ID" /> -->
                    <el-cascader v-model="formData.pid" :props="props" :show-all-levels="false" style="width: 100%" />
                </el-form-item>
                <el-form-item label="分类名称" prop="name">
                    <el-input v-model="formData.name" clearable placeholder="请输入分类名称" />
                </el-form-item>
                <el-form-item label="备注信息" prop="data">
                    <el-input v-model="formData.data" clearable placeholder="请输入备注信息" />
                </el-form-item>

                <el-form-item label="图片" prop="pic">
                    <material-picker v-model="formData.pic" />
                </el-form-item>
                <el-form-item label="排序" prop="sort">
                    <el-input v-model="formData.sort" clearable placeholder="请输入排序" />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="storeCategoryEdit">
import type { FormInstance } from "element-plus";
import Popup from "@/components/popup/index.vue";
import {
    apiStoreCategoryAdd,
    apiStoreCategoryEdit,
    apiStoreCategoryDetail, apiStoreCategoryLists,
} from "@/api/store_category";
import { timeFormat } from "@/utils/util";
import type { PropType } from "vue";
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({}),
    },
});
const emit = defineEmits(["success", "close"]);
const formRef = shallowRef<FormInstance>();
const popupRef = shallowRef<InstanceType<typeof Popup>>();
const mode = ref("add");


const props = {
    value: "id",
    label: "name",
    checkStrictly: true,
    emitPath: false,
    lazy: true,
    lazyLoad(node, resolve) {
        let pid = node.value || 0;
        apiStoreCategoryLists({
            pid: pid,
            page_size: 10000,
        }).then((res) => {
            resolve(
                res.lists.map((item: any) => {
                    item.leaf = item.pid > 0;
                    return item;
                })
            );
        });
    },
};

// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == "edit" ? "编辑商品分类表" : "新增商品分类表";
});

// 表单数据
const formData = reactive({
    id: "",
    pid: 0,
    name: "",
    data: "",
    pic: "",
    sort: "",
});

// 表单验证
const formRules = reactive<any>({
    //   pid: [
    //     {
    //       required: true,
    //       message: "请输入所属ID",
    //       trigger: ["blur"],
    //     },
    //   ],
    name: [
        {
            required: true,
            message: "请输入分类名称",
            trigger: ["blur"],
        },
    ],
});


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key];
        }
    }
};

const getDetail = async (row: Record<string, any>) => {
    const data = await apiStoreCategoryDetail({
        id: row.id,
    });
    setFormData(data);
};

// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate();
    let data = { ...formData };

    mode.value == "edit"
        ? await apiStoreCategoryEdit(data)
        : await apiStoreCategoryAdd(data);
    popupRef.value?.close();
    emit("success");
};

//打开弹窗
const open = (type = "add") => {
    mode.value = type;
    popupRef.value?.open();
};

// 关闭回调
const handleClose = () => {
    emit("close");
};

defineExpose({
    open,
    setFormData,
    getDetail,
});
</script>
